local player = UnitName("player")

-- I have -no clue- why they use _3_ version numbers.
-- That's DBM for you.
local dbmVersion = 2.71
local dbmVERSION = 3.00
local dbmRevision = 736

local function send(msg)
	local instanceType = select(2, IsInInstance())
	if instanceType == "pvp" then
		SendAddonMessage("LVBM NSP", msg, "BATTLEGROUND")
	else
		SendAddonMessage("LVBM NSP", msg, "RAID")
	end
end

local frame = CreateFrame("Frame")
frame:SetScript("OnEvent", function()
	if player ~= arg4 and event == "CHAT_MSG_ADDON" and (arg1 == "LVBM" or arg1 == "LVBM NSP") then

		-- Split all the strings into a table first.
		local tbl = strsplit(" ", arg2)
		if type(tbl) ~= "table" then return end

		-- Then try to find if they sent a version number in the addon message,
		-- and if they did, check if it's more recent than what we have stored
		-- in the variables above, and if it is, update our version accordingly.
		local v, V, r = 0, 0, 0
		if tbl[2] and tonumber(tbl[2]) then
			v, V, r = tonumber(tbl[2]), tonumber(tbl[3]), tonumber(tbl[4])
		elseif tbl[3] and tonumber(tbl[3]) then
			v, V, r = tonumber(tbl[3]), tonumber(tbl[4]), tonumber(tbl[5])
		end
		if v > dbmVersion then dbmVersion = v end
		if V > dbmVERSION then dbmVERSION = V end
		if r > dbmRevision then dbmRevision = r end

		-- Finally, respond to any version queries.
		if tbl[1] == "HI!" or (tbl[1] == "REQ" and tbl[2] == "VER") then
			send("VER " .. tostring(dbmVersion) .. " " .. tostring(dbmVERSION) .. " " .. tostring(dbmRevision))
		end
	end
end)
frame:RegisterEvent("CHAT_MSG_ADDON")

